commit cd41e4a1864c10c7f9141284e82e5cc0a3007806
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Nov 3 21:42:51 2020 +0100

    c++: Don't try to parse a function declaration as deduction guide [PR97663]
    
    While these function declarations have NULL decl_specifiers->type,
    they have still type specifiers specified from which the default int
    in the return type is added, so we shouldn't try to parse those as
    deduction guides.
    
    2020-11-03  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/97663
            * parser.c (cp_parser_init_declarator): Don't try to parse
            C++17 deduction guides if there are any type specifiers even when
            type is NULL.
    
            * g++.dg/cpp1z/class-deduction75.C: New test.
    
    (cherry picked from commit 875225301e356759982573d5578ed7ca54f81f86)

diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index 61264621f6d..846d1aa2a3d 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -20622,6 +20622,7 @@ cp_parser_init_declarator (cp_parser* parser,
     {
       /* Handle C++17 deduction guides.  */
       if (!decl_specifiers->type
+	  && !decl_specifiers->any_type_specifiers_p
 	  && ctor_dtor_or_conv_p <= 0
 	  && cxx_dialect >= cxx17)
 	{
diff --git a/gcc/testsuite/g++.dg/cpp1z/class-deduction75.C b/gcc/testsuite/g++.dg/cpp1z/class-deduction75.C
new file mode 100644
index 00000000000..52e6131c7b5
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp1z/class-deduction75.C
@@ -0,0 +1,15 @@
+// PR c++/97663
+
+template <class T> struct foo {};
+template <class T> struct bar {};
+template <class T> struct baz {};
+template <class T> struct qux {};
+template <class T> struct corge {};
+
+namespace N {
+  unsigned foo ();
+  signed bar ();
+  long baz ();
+  long long qux ();
+  short corge (); 
+}

